import sys
sys.path.insert(0, '..')
sys.path.insert(0, '../shared/netcode')

from concurrent import futures
from shared.netcode.netcode_pb2 import *
from shared.netcode.netcode_pb2_grpc import *


class NotifierService(NotifierCommunicationServicer):
    def Open(self, request, context):
        # TODO: append id_code to list
        # TODO: wait for id_code answered
        # TODO: return comm_id
        return CommResponse()

    def Answer(self, request, context):
        # TODO: check if if_code can be answered
        # TODO: return comm_id
        return CommResponse()

    def ReceiveMessage(self, request, context):
        # TODO: read comm_id and wait for messages
        yield Message(comm_id=-1, content="test")

    def SendMessage(self, request_iterator, context):
        for msg in request_iterator:
            # TODO: read comm_id and route message
            print(msg.comm_id)
            print(msg.content)
        return Nothing()


if __name__ == "__main__":
    server = grpc.server(futures.ThreadPoolExecutor(max_workers=10))
    add_NotifierCommunicationServicer_to_server(
        NotifierService(), server)
    server.add_insecure_port('[::]:8080')
    server.start()
    server.wait_for_termination()
