# mobile-sec-notifier

Two chat participants [A]lice and [B]ob.
Send encrypted messages indirectly via the server between A and B.
A and B in distinct networks.

# TODO:

- [ ] Protocol
- [ ] Server (python)
- [ ] Python-Client
- [ ] Android-Client

# Prototype 1:

- [x] Python-Server & Python-Test-Client
    - [x] Exchange messages server<->client using protobuf
- [x] Android-Client
    - [x] Grab notifications
    - [ ] Communicate with grpc service
- [ ] Create protocol

# Prototype 2:

- [ ] Python-Test-Client:
    - [ ] Register to server / authenticate at the server
    - [ ] Establish ephemeral key with target client
        - Client-to-client key exchange (asym. encryption)
    - [ ] Exchange messages using AES with ephemeral key

# Prototype 3:

- [ ] Harden against attacks (for reference: https://core.telegram.org/techfaq#protection-against-known-attacks)